import QtQuick 2.12

ScalableImage {
    id: root

    sourceName: "Components/BPM_Icon";
    
    fillMode: Image.PreserveAspectFit
    state: "Normal"
    smooth: true
    states: [
        State{
            name: "Expanded"
            PropertyChanges {target: root; scale: 1.15}
        },
        State{
            name: "Normal"
            PropertyChanges {target: root; scale: 0.85}
        }
    ]

    transitions:
        Transition {
                    from: "Normal"
                    to: "Expanded"
                    reversible: true
                    SequentialAnimation {
                        NumberAnimation { duration: beatingHeartTimer.interval; properties: "scale"; easing.type: Easing.InOutBounce }
                    }
                }

    Timer{
        id:beatingHeartTimer
        interval: 600
        repeat: true
        running: root.visible
        triggeredOnStart: true
        onTriggered: {
            if(parent.state == "Expanded") parent.state = "Normal"
            else parent.state = "Expanded"
        }
        onRunningChanged:{
            if(!running) parent.state = "Normal"
        }
    }

    Connections {
        target: heartRateManager
        onHeartRateChanged: {
            if(heartRateManager.heartRate > 0)
                beatingHeartTimer.interval = 1000/(heartRateManager.heartRate/60);
        }
    }
}
