import QtQuick 2.12

Item {
    id: root

    property string label: "----"
    property string labelColor: main.colorFontDark
    property string edgeColor: main.colorDiagnosticEdges
    property string highlightColor: main.colorFontGreen
//    property int labelWidth: labelArea.implicitWidth
    property bool readOnly: false
    property bool value: false
    property alias font: labelArea.font
    property int boxSize: 25 * main.vScaleFactor

    height: visible ? enclosingRect.height : 0
    width: 50 * main.hScaleFactor

    signal pressed()


    Row {
        id: enclosingRect
        width: parent.width
        height: Math.max(labelArea.height, root.boxSize)
        spacing: 15 * main.vScaleFactor
        LayoutMirroring.enabled: main.rightToLeft

        Rectangle {
            id: checkboxArea
            anchors.verticalCenter: parent.verticalCenter

            width: height
            height: root.boxSize
            border.color: root.edgeColor
            border.width: main.widthBorder
            color: root.value ? root.highlightColor : "transparent"

            MouseArea {
                id: clickArea
                anchors.fill: parent
                enabled: !root.readOnly
                onPressed: {
                    if (!root.readOnly) {
                        root.value = !root.value
                        root.pressed()
                    }
                }
                Rectangle {
                    anchors.fill: parent
                    color: main.colorGenericStimulusArea
                    opacity: 0.3
                    visible: main.showStimulusArea
                }
            }
        }

        TextLabel{
            id: labelArea
            text: label
            width: 0.8 * parent.width
            font.pixelSize: 0.8 * checkboxArea.height
            anchors.verticalCenter: parent.verticalCenter
            color: root.labelColor
            wrapMode: Text.WordWrap
        }
    }
}
