import QtQuick 2.12

// prompt user for ending the workout

ModalDialog {
    id: root
    blockKeys: true

    property string prompt: qsTr("Are you sure?")
    property string yesText: qsTr("YES") + application.emptyString
    property string noText: qsTr("NO") + application.emptyString

//    property int borderWidth: 800
//    property int borderHeight: 350
    property int textXOffset: 149
    property int textSize: 40

    signal yesClicked()
    signal noClicked()

    Item {
        z: root.z + 1
        anchors.fill: parent

        Text {
            id: endPromptText
            x: textXOffset * main.hScaleFactor
            y: 35 * main.vScaleFactor
            width: 501 * main.hScaleFactor
            height: 99 * main.vScaleFactor
            color: main.colorFontLight
            text: root.prompt
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.top: parent.top
            anchors.topMargin: 35 * main.vScaleFactor
            horizontalAlignment: Text.AlignHCenter
            wrapMode: Text.WordWrap
            font.bold: false
            font.pixelSize: textSize * main.vScaleFactor
        }



        StandardButton {
            id: noButton
            x: 538 * main.hScaleFactor
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 22 * main.vScaleFactor

            sourceName: "stop_button_icon"
            buttonText: root.noText
            onClicked: noClicked()
        }

        StandardButton {
            id: yesButton

            x: 149 * main.hScaleFactor
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 22 * main.vScaleFactor

            sourceName: "HomeScreen/QuickStartIcon"
            buttonText: root.yesText
            onClicked: yesClicked()
        }
    }
}

