import QtQuick 2.12

ModalDialog {
    id: root

    property string message: "Notice"

    Component.onCompleted: hide()
    onTimedOut: hide()  // hide the pop-up when timer expires

    function showMessage(string, seconds) {
        message = string
        showWithTimeout(seconds)
    }

    function showWithTimeout(seconds) {
        buzzer.buttonPress()
        startTimeout(seconds)
        show()
    }

    function show() {
        visible = true
   }

    width: 831 * main.hScaleFactor
    height: 86 * main.vScaleFactor

    Text {
        id: bannerText
        anchors.verticalCenter: parent.verticalCenter
        anchors.horizontalCenter: parent.horizontalCenter
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        scale: paintedWidth > parent.width ? (parent.width/ paintedWidth) : 1
        height: parent.height
        width: paintedWidth
        color: main.colorFontLight
        text: root.message
        font.bold: false
        font.pixelSize: 40 * main.vScaleFactor
        z: root.z + 1
    }
}
