// MessagePopup - A modal rectoval pop-up window with a text message.  Optional timeout.

import QtQuick 2.12

ModalDialog{
    id: root

    property alias messageColor: popupText.color
    property string message
    property bool clickThrough: false
    width: main.widthDialog
    height: main.heightDialog
    x: (main.width - width) / 2
    y: (main.height - height) / 2

    onTimedOut: hide()  // hide the pop-up when timer expires
    visible: false
    dismissAnywhere: true

    function showWithTimeout(seconds) {
        buzzer.buttonPress()
        startTimeout(seconds)
        show()
    }

    function showMessage(string, seconds) {
        message = string
        showWithTimeout(seconds)
    }

    Text {
        id: popupText
        anchors.fill: parent
        anchors.margins: 30 * main.scaleFactor
        anchors.verticalCenter: parent.verticalCenter
        color: main.colorFontLight
        anchors.horizontalCenter: parent.horizontalCenter
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        wrapMode: Text.WordWrap
        font.bold: false
        font.pixelSize: 50 * main.vScaleFactor
        text: root.message
        z: root.z+1
    }
}
