import QtQuick 2.12

Item {
    id: root

    property alias value: control.value
    property string displayValue: value
    property string headingString: ""
    property int minValue: 0
    property int maxValue: 100
    property bool sliderVisible: true
    property alias stepValue: control.stepValue
    property string labelColor: main.colorFontDark

    width: parent.width
    height: (visible && opacity >0) ? 56 * main.vScaleFactor : 0

    TextLabel{
        id: heading
        text: headingString
        anchors.verticalCenter: root.verticalCenter
        anchors.left: root.left
        color: root.labelColor
        width: main.rightToLeft ? 0.3 * root.width : 0.4 * root.width
        height: root.height
        wrapMode: Text.WordWrap
        font.pixelSize: 20* main.vScaleFactor
        verticalAlignment: Text.AlignVCenter
    }

    NumberLabel{
        id:valueString
        text: displayValue
        anchors.verticalCenter: root.verticalCenter
        anchors.right: control.left
        anchors.rightMargin: 20 * main.hScaleFactor
        color: root.labelColor
        width: main.rightToLeft ? 0.3 * root.width : 0.2 * root.width
        font.pixelSize: 16 * main.vScaleFactor
        verticalAlignment: Text.AlignVCenter
        horizontalAlignment: Text.AlignRight
    }

    SliderControl{
        id: control
        visible: sliderVisible
        width: 0.4 * root.width
        height: root.height
        anchors.verticalCenter: root.verticalCenter
        anchors.right: root.right
        minValue: root.minValue
        maxValue: root.maxValue
        onValueChanged: root.value = value
        showValue: false
        sliderColor: main.colorDiagnosticEdges
        isArrowSliderType: true
    }

}
