import QtQuick 2.12
import Components 1.0
import "../"

Item {
    id: root
    property url pos0image: "graphics/ToggleButton/Toggle_On.png"
    property url pos0image_disabled: "graphics/ToggleButton/Toggle_Disabled_True.png"
    property url pos1image: "graphics/ToggleButton/Toggle_Off.png"
    property url pos1image_disabled: "graphics/ToggleButton/Toggle_Disabled.png"
    property string pos0label: "0"
    property string pos1label: "1"
    property bool showLabels: true
    property bool   value
    property string labelcolor: main.colorFontDark
    property string highlightColor: "transparent"
    property alias posFont: pos0text.font

    width: childrenRect.width
    height: 25 * main.vScaleFactor

    Rectangle {
        id: button

        anchors.horizontalCenter: parent.horizontalCenter
        height: parent.height
        width: 1.85 * parent.height

        color: "transparent"
        border.color: root.labelcolor
        border.width: 3 * main.scaleFactor
        radius: 5 * main.scaleFactor

        Rectangle {
            id: buttonKnob

            width: height
            height: 0.9*parent.height
            anchors.verticalCenter: parent.verticalCenter
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.horizontalCenterOffset: root.value ? width/2 : -width/2
            color: main.colorUIBorder
            radius: 5 * main.scaleFactor
        }

        MouseArea {
            anchors.fill: parent
            anchors.margins: -5 * main.scaleFactor
            onClicked: {
                root.value = !root.value
            }

            Rectangle {
                anchors.fill: parent
                color: main.colorKnobStimulusArea
                opacity: 0.3
                visible: main.showStimulusArea
            }
        }
    }

    Text {
        id: pos0text
        text: pos0label
        anchors { right: button.left ; rightMargin: 5 * main.hScaleFactor; verticalCenter: button.verticalCenter}
        horizontalAlignment: Text.AlignRight
        height: parent.height
        color: root.value ? highlightColor : labelcolor
        visible: showLabels
    }

    Text {
        id: pos1text
        text: pos1label
        anchors { left: button.right ; leftMargin: 5 * main.hScaleFactor; verticalCenter: button.verticalCenter}
        horizontalAlignment: Text.AlignLeft
        height: parent.height
        color: root.value ? labelcolor : highlightColor
        font: pos0text.font
        visible: showLabels
    }
}
