import QtQuick 2.12

//import VLCVideo 1.0
import Components 1.0
import ".."

Item {

    id: root

    //width: 850 * main.hScaleFactor
    //height: 556 * main.vScaleFactor

//    anchors.verticalCenter: parent.verticalCenter
//    anchors.horizontalCenter: parent.horizontalCenter

    width: main.widthDialog
    height: main.heightDialog

    property bool showCloseButton: true
    property int highlightedItem:1
    property bool isDialogVisible: false
    property variant menu
    property int menu_bottom_margin: 70
    property bool videoShown: false
    property bool viewShowing: false
//    property bool keysAccepted: false
    property bool allowFullscreen: false
    property variant currentBtPlayer: bluetoothAdapter.currentConnectedDevice !== null ? bluetoothAdapter.currentConnectedDevice.player : undefined
//    property bool ipodVideoShowing: videoShown && (videoView.visible || fullscreenVideoFrame.visible)

    // possible dialogState values
    // - idle: mediaBrowserNoDeviceConnectedDialog is displayed
    // - connecting: btConnectionStatusDialog is displayed
    // - help: btHelpDialog is displayed
    // - connected: mediaBrowserNoDeviceConnectedDialog is displayed
    property string dialogState: ""

    Component.onCompleted: {
        dialogState = "idle"
    }

    onDialogStateChanged: {
        if(dialogState === "idle") {
            btConnectionStatusDialog.show()
        } else if(dialogState === "connecting") {
            btConnectionStatusDialog.show()
        } else if(dialogState === "help") {
            btConnectionStatusDialog.hide()
        } else if(dialogState === "connected") {
            btConnectionStatusDialog.hide()
        } else if(dialogState === "disconnecting") {
            btConnectionStatusDialog.show()
        }
    }

    function shown() {
        viewShowing = true
        if (audioManager.btconnected) {
            audioManager.btRequest()
        }
    }

    function hidden() {
        viewShowing = false
    }

    signal close()

    BluetoothDeviceSelectionDialog{
        id: btConnectionStatusDialog
        isTop: false
        list: bluetoothAdapter.scannedHeadSets
        pairingAllowed: !(bluetoothAdapter.pairing || bluetoothAdapter.connectingHeadset)
        opacity: 1.0

        onClosed: {
            dialogState = "idle"
            close()
        }
        onHeadsetConnected: dialogState = "connected"
        onHeadsetDisconnected: dialogState = "idle"
    }

}



