import QtQuick 2.12
import Components 1.0

Item{

    id: root

    x: 30
    opacity: buttonEnabled ? 1.0 : 0.5

    property string labelString: ""
    property string statusString: ""
    property string statusColor: main.colorFontDark
    property bool buttonEnabled: true
    property bool buttonVisible: true
    property alias selected: button.selected

    signal buttonPressed()

    function enterPressed() {
        if(buttonEnabled) {
            buttonPressed()
        }
    }

    Text {
        id: statusLabel
        text: statusString
        color: statusColor
        anchors.verticalCenter: parent.verticalCenter
        anchors.left: button.right
        anchors.leftMargin: 30 * main.hScaleFactor
        width: 250 * main.hScaleFactor
        height: parent.height
        verticalAlignment: Text.AlignVCenter
        wrapMode: Text.WordWrap
    }

    StandardButton {
        id: button
        buttonText: labelString
        anchors.verticalCenter: parent.verticalCenter
        anchors.left: parent.left
        height: 0.8 * parent.height
        width: 250 * main.hScaleFactor
        enabled: buttonEnabled
        visible: buttonVisible
        onClicked: {
            buttonPressed()
        }
    }
}


