import QtQuick 2.12
import ".."
import Components 1.0

Rectangle {
    id: root

    property alias model: countryList.model
    property alias modelTranslationContext: countryList.modelTranslationContext
    property alias currentIndex: countryList.currentIndex
    property alias selectedData: countryList.selectedData
    function incrementCurrentIndex() { countryList.incrementCurrentIndex() }
    function decrementCurrentIndex() { countryList.decrementCurrentIndex() }

    signal itemSelected(int index)
    signal close()

    z: 300
    visible: false
    color: main.colorDialogBackground
    border.color: main.colorUIBorder
    border.width: main.widthBorder
    radius: 5 * main.scaleFactor
    width: 350 * main.hScaleFactor
    height: 580 * main.vScaleFactor
//    anchors.fill: parent

    onClose: {
        root.visible = false
    }

    CloseButton { // x
        anchors {
            right: parent.right
            rightMargin: 5 * main.hScaleFactor
            top: parent.top
            topMargin: 5 * main.vScaleFactor
        }
        width: 25 * main.hScaleFactor
        height: 25 * main.vScaleFactor
        z: 200
        onClicked: root.close()
    }

    SelectList {
        id: countryList

        onItemSelected: root.itemSelected(index)

        x: 50 * main.hScaleFactor
        y: 80 * main.vScaleFactor
        width: 247 * main.hScaleFactor
        height: 450 * main.vScaleFactor
        fontColor: main.colorFontLight
    }

    TextLabel {
        id: countryListLabel

        text: qsTr("Choose Country") + application.emptyString
        anchors {
            top: parent.top; topMargin: 10 * main.vScaleFactor
            left: parent.left; leftMargin: 30 * main.hScaleFactor
        }
        font.pixelSize: 16
    }
}
