import QtQuick 2.12
import Components 1.0
//import NetworkRequest 1.0
import EGym 1.0
import "../Keypad"

Item {
    id: root

    anchors {
        fill: parent
        margins: 10  * main.hScaleFactor
    }

    property alias gymID: unameInput.text
    property alias gymPassword: upassInput.text

    onGymIDChanged: {
        options.egymID = gymID
        eGym.gymID = gymID
    }

    onGymPasswordChanged: {
        options.egymPassword = gymPassword
        eGym.gymPassword = gymPassword
    }

    Item{
        id: headingSection

        anchors.top: parent.top
        anchors.left: parent.left
        anchors.right: parent.right
        height: 100 * main.vScaleFactor

        TextLabel{
            id: heading
            text: qsTranslate("Diagnostics", "EGym Registration") + application.emptyString
            font.pixelSize: 36 * main.vScaleFactor
            anchors.fill: parent
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
            color: main.colorFontDark
        }

        TextLabel{
            id:serialNumber
            font.pixelSize: 12 * main.vScaleFactor
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 3 * main.vScaleFactor
            color: main.colorFontDark

            text:qsTr("Serial: ") + main.serialNumber + "   " + qsTr("Type: ") + machineinfo.productTypeString + application.emptyString
        }
    }

    Column {
        spacing: 10 * main.hScaleFactor
        anchors {
            top: headingSection.bottom
            left: parent.left
            right: parent.right
            margins: 20 * main.hScaleFactor
            bottom: parent.bottom
        }

        TextLabel {
            id: unameLabel

            width: parent.width
            font.pixelSize: 16 * main.vScaleFactor
            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignTop
            color: main.colorFontDark
            text: qsTr("Enter Gym ID:") + application.emptyString
        }

        TextInput {
            id: unameInput

            width: parent.width
            text: eGym.gymID

            Rectangle {
                color: "transparent"
                border.color: main.colorDiagnosticEdges
                anchors.fill: parent
                anchors.margins: -2*main.vScaleFactor
                z: parent.z-1
            }
        }

        TextLabel {
            id: upassLabel

            width: parent.width
            font.pixelSize: 16 * main.vScaleFactor
            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignTop
            color: main.colorFontDark
            text: qsTr("Enter Gym Password:") + application.emptyString
        }

        TextInput {
            id: upassInput
            width: parent.width
            text: eGym.gymPassword

            Rectangle {
                color: "transparent"
                border.color: main.colorDiagnosticEdges
                anchors.fill: parent
                anchors.margins: -2*main.vScaleFactor
                z: parent.z-1
            }
        }
    }

    TrueKeyboard {
        id: keyboard
        width: root.width
        anchors.horizontalCenter: root.horizontalCenter
        z: 999999
        active: unameInput.activeFocus || upassInput.activeFocus
        useMain: false
    }
}
