import QtQuick 2.12
import Process 0.1

Item {
    id: root

    property bool isEnabled: false
    property bool running: clientProcess.processState === Process.Running
    property bool starting: clientProcess.processState === Process.Starting
    property bool success: false

    onSuccessChanged: console.log("RemoteAccess success?", success)

    Component.onDestruction: {
        console.log("Ending SSH connections")
        clientProcess.terminate()
    }

    onIsEnabledChanged: {
        success = false
        if (isEnabled) {
            clientProcess.start()
        } else {
            clientProcess.terminate()
        }
    }

    Process {
        id: clientProcess
        program: "scripts/remote_access/loop.sh"
        onReadyReadStandardOutput: {
            var data = new String(readAllStandardOutput())
            if (data.indexOf("Reconnecting") >= 0) {
                root.success = false
            }
        }

        onReadyReadStandardError: {
            var data = new String(readAllStandardError())
            if (data.indexOf("remote forward success") >= 0) {
                root.success = true
            }
        }
    }

}
