import QtQuick 2.12
import Components 1.0


Item {
    id: root

    property string title
    property string artist
    property string album
    property int duration: 200
    property int position: 0
//    property bool scrubControlVisible: true

    signal scrub(int new_time)

    Column {
        anchors.fill: root
        spacing: 10 * main.vScaleFactor

        TextLabel {
            id: now_playing_title
            text: qsTr("NOW PLAYING") + application.emptyString
            horizontalAlignment: Text.AlignHCenter
            width: parent.width * 0.9
            height: 50 * main.vScaleFactor
        }

        Item {
            height: 50 * main.vScaleFactor
        }

        TextLabel {
            id: title_text
            text: root.title
            horizontalAlignment: Text.AlignHCenter
            clip: true
            wrapMode: Text.WordWrap
            width: parent.width * 0.9
        }

        TextLabel {
            id: artist_text
            text: root.artist
            wrapMode: Text.WordWrap
            width: parent.width * 0.9
            horizontalAlignment: Text.AlignHCenter
        }

        TextLabel {
            id: album_text
            text: root.album
            wrapMode: Text.WordWrap
            width: parent.width * 0.9
            horizontalAlignment: Text.AlignHCenter
        }


        /*ScrubControl {
        id: scrub_control

        visible: scrubControlVisible

        duration: root.duration
        position: root.position

        onScrub: { root.scrub(new_time) }

        anchors.bottom: parent.bottom
        anchors.bottomMargin: 40 * main.vScaleFactor
        anchors.right: parent.right
        anchors.rightMargin: 30 * main.hScaleFactor
        anchors.left: parent.left
        anchors.leftMargin: 50 * main.hScaleFactor

    }*/
    }
}
