import QtQuick 2.12
import Components 1.0
import "../LanguageMenu"

Item {
    id: root

    signal languageSelected(string lang)

    LanguageSelectionComponent {
        id: languageSelectionGrid
        onLanguageSelected: parent.languageSelected(lang)
    }

    Column {
        id: unitsCol

        spacing: 30 * main.vScaleFactor
        anchors {
            right: parent.right
            rightMargin: 40 * main.hScaleFactor
            top: parent.top
            topMargin: 20 * main.vScaleFactor
        }

        StandardButton {
            id: imperialButton
            enabled: true
            buttonText: qsTr("U.S.") + application.emptyString
            label.font.pixelSize: 16 * main.vScaleFactor

            selected: !options.metricUnits
            onClicked: options.metricUnits = false
        }

        StandardButton {
            id: metricButton
            enabled: true
            buttonText: qsTr("Metric") + application.emptyString
            label.font.pixelSize: 16 * main.vScaleFactor

            selected: options.metricUnits
            onClicked: options.metricUnits = true
        }
    }
}
