import QtQuick 2.12
import Components 1.0

// Prompts for heart rate control programs

ModalDialog {
    id: root

    property string msgText: qsTranslate("HeartRatePrompts", "NA")

    Component.onCompleted: {
        msgModel.append({"msg":QT_TRANSLATE_NOOP("HeartRatePrompts", "APPROACHING")});
        msgModel.append({"msg":QT_TRANSLATE_NOOP("HeartRatePrompts", "WORKOUT BEGINNING")});
        msgModel.append({"msg":QT_TRANSLATE_NOOP("HeartRatePrompts", "STOPPING: HEART RATE EXCEEDING 12 BPM OF TARGET")});
        msgModel.append({"msg":QT_TRANSLATE_NOOP("HeartRatePrompts", "WORKOUT ENDING")});
        msgModel.append({"msg":QT_TRANSLATE_NOOP("HeartRatePrompts", "FITNESS TEST ENDING")});
        msgModel.append({"msg":QT_TRANSLATE_NOOP("HeartRatePrompts", "ENTERING HRC MODE")});
        msgModel.append({"msg":QT_TRANSLATE_NOOP("HeartRatePrompts", "TARGET HEART RATE REACHED")});
        msgModel.append({"msg":QT_TRANSLATE_NOOP("HeartRatePrompts", "ENTERING REST MODE")});
    }

    function getMsg(index) {
        return qsTranslate("HeartRatePrompts", msgModel.get(index).msg);
    }

    function setMsg(index) {
        root.msgText = qsTranslate("HeartRatePrompts", msgModel.get(index).msg);
    }

    dismissable: true
    dismissAnywhere: true
    isTransparent: true

    TextLabel {
        id: promptText
        width: 501 * main.hScaleFactor
        height: 99 * main.vScaleFactor
        text: root.msgText  + application.emptyString
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.verticalCenter: parent.verticalCenter
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        wrapMode: Text.WordWrap
        font.pixelSize: 40 * main.vScaleFactor
        z: root.z + 1
    }

    ListModel {
        id: msgModel
    }
}

