import QtQuick 2.12
import Components 1.0
import ".."

// prompt user for ending the workout

ModalDialog {
    id: root

    blockKeys: true

    signal resumeClicked()

    Item {
        z: root.z + 1
        anchors.fill: parent

        TextLabel {
            id: noUserDetectedText

            text: qsTr("NO USER DETECTED.") + application.emptyString
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.top: parent.top
            anchors.topMargin: 20 * main.vScaleFactor
            horizontalAlignment: Text.AlignHCenter
            wrapMode: Text.WordWrap
            font.pixelSize: 50 * main.vScaleFactor
        }

        TextLabel {
            id: pressToContinueText

            text: qsTr("PRESS TO CONTINUE:") + application.emptyString
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.top: noUserDetectedText.bottom
            anchors.topMargin: 0
            horizontalAlignment: Text.AlignHCenter
            wrapMode: Text.WordWrap
            font.pixelSize: 25 * main.vScaleFactor
        }

        StandardButton {
            id: resumeButton

            anchors.top: pressToContinueText.bottom
            anchors.topMargin: 0
            anchors.horizontalCenter: parent.horizontalCenter
            buttonText: qsTr("RESUME WORKOUT") + application.emptyString
            onClicked: resumeClicked()

            icon.sourceName: "HomeScreen/QuickStartIcon"
        }

        NumberLabel { // show count down to timeout of prompt (started by startTimeout(seconds) method of ModalDialog superclass
            id: countdownText

            // display count down (with a leading 0 if remaining seconds < 10
            text: ":" + ((countDown.toString().length < 2) ? "0" : "") + countDown
            font.pixelSize: 80 * main.vScaleFactor
            horizontalAlignment: Text.AlignHCenter
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.top: resumeButton.bottom
            anchors.topMargin: 30 * main.vScaleFactor
        }
    }
}

