// Code common to SetupParams

function setParameter(type, value) {
    if(!root.model)
        return
    var obj = root.model.find("fieldType", type)
    if(obj) {
        root.valueEntered = true
        if(value > obj.maxValue)
            obj.dataValue = obj.maxValue
        else if(value < obj.minValue)
            obj.dataValue = obj.minValue
        else
            obj.dataValue = value
        root.valueEntered = false
    }
}
function returnSpeedIncline(fieldType,speedValue,inclineValue,flag){
    console.log("fieldType:::::::,speedValue:::::::::,inclineValue",fieldType,speedValue,inclineValue)
    var index18
     var index25
    if (fieldType === "speed") {
         if (speedValue >= 9.0 && inclineValue > 18.5) {
             if(flag===0){
                      index18 = workoutProgram.tableIndexOfClosestValue(workoutProgram.inclineTable, 185)
                     return index18
         } else if(flag===1 )
             {
                 if(inclineValue>25.0)
                     index18=25.0
                 else
                     index18=18.5

             return index18

             }
         }else if (speedValue >= 6.0 && inclineValue > 25.0) {
             if(flag===0){
                      index25 = workoutProgram.tableIndexOfClosestValue(workoutProgram.inclineTable, 250)
                     return index25
             }else if(flag===1)
             {

                  index25=25.0
             return index25

             }
         }
    } else if (fieldType === "incline") {
         if (inclineValue >= 25.5 && speedValue > 6.0) {
                     return 6.0
         }else if (inclineValue >= 19.0 && speedValue > 9.0) {
                     return 9.0
         }
    }
}

function setAlpineCustomMaxValue(fieldType, value) {
    if (!main.isAlpineRunner) {
        return
    }

    var fieldTypes = {"incline": WorkoutProgram.INCLINE_TYPE, "speed": WorkoutProgram.SPEED_TYPE};
    if (fieldType === WorkoutProgram.MAX_SPEED_TYPE || fieldType === WorkoutProgram.MAX_INCLINE_TYPE) {
        // Special case for Calorie Goal program
        fieldTypes["incline"] = WorkoutProgram.MAX_INCLINE_TYPE
        fieldTypes["speed"] = WorkoutProgram.MAX_SPEED_TYPE
    }

    var speed
    var incline
    var inclineIndex
    if (fieldType === fieldTypes["speed"]) {
        speed = value
        if (speed <= 6.0) {
            return
        }

        inclineIndex = getParameter(fieldTypes["incline"])
        if (inclineIndex === undefined) {
            return
        }

        incline = (workoutProgram.inclineTable[inclineIndex]/10).toFixed(1)
       var inclineValue1=returnSpeedIncline("speed",speed,incline,0)
       if(inclineValue1)
         setParameter(fieldTypes["incline"], inclineValue1)

    } else if (fieldType === fieldTypes["incline"]) {
        inclineIndex = value
        incline = (workoutProgram.inclineTable[inclineIndex]/10).toFixed(1)
        if (incline <= 18.5) {
            return
        }

        speed = getParameter(fieldTypes["incline"])
         if (speed === undefined) {
            return
        }
        speed = parseFloat(speed)
        var speedValue1=returnSpeedIncline("incline",speed,incline,0)
        if(speedValue1)
        setParameter(fieldTypes["speed"], speedValue1)

     }
}

function getParameter(type) {
    if(!myListView.model)
        return

    var obj
    for (var j=0; j < myListView.model.count; j++) {
        if(myListView.model.get(j).fieldType === type) {
            obj = myListView.model.get(j)
            break
        }
    }

    if(obj)
        return obj.dataValue
    else
        return undefined
}

function maxTreadCalories( speed, incline, weight, time) {
    var calsPerHr = workoutManager.treadmillCalsPerHour(speed, incline, weight)
    return time * calsPerHr / 60.0
}

function validateTreadCalorieGoal() {
    var speed = getParameter(WorkoutProgram.MAX_SPEED_TYPE)
    var inclineIndex = getParameter(WorkoutProgram.MAX_INCLINE_TYPE)
    var incline = (workoutProgram.inclineTable[inclineIndex]/10).toFixed(1)
    var weight = getParameter(WorkoutProgram.WEIGHT_TYPE)
    if (root.model.find("fieldType", WorkoutProgram.WEIGHT_TYPE).units === "KG") {
        weight = Math.round(Globals.kgToPound(weight))
    }
    var time = getParameter(WorkoutProgram.TIME_TYPE)
    var maxCal = maxTreadCalories(speed, incline, weight, time)
    var calgoal = getParameter(WorkoutProgram.CALORIES_TYPE)
    setParameter(WorkoutProgram.CALORIE_POTENTIAL_TYPE, maxCal.toFixed(0))

    if(calgoal > maxCal) {
        setParameter(WorkoutProgram.CALORIES_TYPE, maxCal.toFixed(0))
    }
}

function validateNonTreadCalorieGoal() {
    // when weight, time, or calories change, recalculate max and show warning if needed
    var weight = getParameter(WorkoutProgram.WEIGHT_TYPE)
    root.maxCalPerHr = workoutManager.bikeEllipticalMaxCalsPerHour(weight)
    var calsperhr = Math.floor(calItem.dataValue / (timeItem.dataValue / 60))
    console.log("max cals per hr is", root.maxCalPerHr, "user cals per hour is", calsperhr)
    if (calsperhr > root.maxCalPerHr) {
        calWarning.visible = true
    } else {
        calWarning.visible = false
    }
}

function isSpeedType(fieldType) {
    switch (fieldType) {
    case WorkoutProgram.SPEED_TYPE:
    case WorkoutProgram.MAX_SPEED_TYPE:
    case WorkoutProgram.WALK_SPEED_TYPE:
    case WorkoutProgram.RUN_SPEED_TYPE:
    case WorkoutProgram.WORK_SPEED_TYPE:
    case WorkoutProgram.REST_SPEED_TYPE:
        return true
    default:
        return false
    }
}

function isStrideType(fieldType) {
    return fieldType === WorkoutProgram.MIN_STRIDE_TYPE || fieldType === WorkoutProgram.MAX_STRIDE_TYPE
}

function modelPostProcessing()
{

    if(calWarning !== undefined) calWarning.visible = false

    // get references to the time and distance model items for making the time/dist mutex for manual workout
    timeItem = root.model.find("fieldType", WorkoutProgram.TIME_TYPE)
    if (timeItem) {
        root.model.setProperty(timeItem.fieldIndex - 1, "maxValue", options.workoutTimeMax)
        if (timeItem.dataValue > 0)
            setParameter(WorkoutProgram.TIME_TYPE, timeItem.dataValue) // re-set value in case it is now over max
    }

    distItem = root.model.find("fieldType", WorkoutProgram.DISTANCE_TYPE)
    if(!distItem) {
        distItem = root.model.find("fieldType", WorkoutProgram.DISTANCE_QUICK_TYPE)
        if (!distItem) {
            distItem = root.model.find("fieldType", WorkoutProgram.FIXED_DISTANCE_TYPE)
            if (distItem) {
                console.log("Fixed Dist Item!")
            }
        }
    }

    if(isTreadmill || main.isStepmill)
        calItem = root.model.find("fieldType", WorkoutProgram.CALORIE_POTENTIAL_TYPE)
    else
        calItem = root.model.find("fieldType", WorkoutProgram.CALORIES_TYPE)


    if((isTreadmill || main.isStepmill) && calItem) {
        validateTreadCalorieGoal()
    }
    if (!(isTreadmill || main.isStepmill) && calItem) {
        validateNonTreadCalorieGoal()
    }

    root.timeGoal = false
    root.distGoal = false
    if(timeItem && timeItem.dataValue > 0)
        root.timeGoal = true
    else if(distItem)
        root.distGoal = true

    root.startIndex = 0
    for(var i = 0; i < myListView.model.count; i++)
    {
        var item = myListView.model.get(i)
        var isCruseHR = !workoutProgram.isHRCProgram && item.fieldType === WorkoutProgram.TARGET_HEARTRATE_TYPE
        var showIfAdjustable = item.fieldAdjustable && root.isCruiseControlEnabled === isCruseHR

        if(root.isAdjustWorkout && !showIfAdjustable && i <= root.startIndex) {
            root.startIndex++
        }

        switch(item.fieldType)
        {
        case WorkoutProgram.WORK_HEARTRATE_TYPE:
        case WorkoutProgram.REST_HEARTRATE_TYPE:
        case WorkoutProgram.TARGET_HEARTRATE_TYPE:
            mainProgItem.targetHRType = mainProgItem.targetHRTypeEnum.target; // Target
            calculateHRPercentage();
            break;

        case WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE:
            mainProgItem.targetHRType = mainProgItem.targetHRTypeEnum.aerobic; // Aerobic
            calculateHRFromAge();
            break;
        case WorkoutProgram.SEGMENT_TYPE:
            mainProgItem.numSegs = item.dataValue;
            break;
        case WorkoutProgram.TIME_TYPE:
            mainProgItem.workTime = item.dataValue;
            break;
        case WorkoutProgram.DISTANCE_TYPE:
            break;
        case WorkoutProgram.PACE_TYPE:
            mainProgItem.paceLevelForCustom = item.dataValue;
            break;
        case WorkoutProgram.WORKLOAD_TYPE:
            mainProgItem.workloadLevelForCustom = item.dataValue;
            break;
        case WorkoutProgram.AGE_TYPE:
            mainProgItem.ageForProgSummary = item.dataValue;
            break;
        case WorkoutProgram.WEIGHT_TYPE:
            mainProgItem.weightForProgSummary = item.dataValue;
            break;
        }
    }
    mainProgItem.dataItemChanged()

    keypad.clear()
    if(root.startIndex > myListView.model.count)
        root.startIndex = 0

    if (root.startIndex >= myListView.model.count )
        root.startIndex = 0

    root.selectedIndex = root.startIndex
    if (root.selectedIndex >= 0) {
        var item = myListView.model.get(root.selectedIndex)
        keypad.length = getMaxDigit(item.maxValue)
        console.debug("index changed to ", root.selectedIndex, ". Max Value is ", item.maxValue, ". Length is ", keypad.length)
    }
}

function validateParam(i) {
    var item = myListView.model.get(i)
    var correctionsMade = 0
    var newValue = item.dataValue

    // skip ignored values in mutual exclusive goal setting (manual workout time vs. distance)
    if(root.timeGoal && item.fieldType === WorkoutProgram.DISTANCE_TYPE)
        return 0
    if(root.distGoal && item.fieldType === WorkoutProgram.TIME_TYPE)
        return 0

    if (item.dataValue > item.maxValue) {
        newValue = item.maxValue
        // Change invalid speed entries of any type to minimum speed
        if(item.fieldType == WorkoutProgram.SPEED_TYPE || item.fieldType == WorkoutProgram.MAX_SPEED_TYPE ||
                item.fieldType == WorkoutProgram.WORK_SPEED_TYPE || item.fieldType == WorkoutProgram.REST_SPEED_TYPE ||
                item.fieldType == WorkoutProgram.RUN_SPEED_TYPE  || item.fieldType == WorkoutProgram.WALK_SPEED_TYPE){
            newValue = item.minValue
        }
        // Change invalid incline entries to zero grade
        else if(item.units === "%"){
            newValue = 0
        }
    }
    else if (item.dataValue < item.minValue) {
        newValue = item.minValue
    }

    if(item.dataValue !== newValue) {
        root.valueEntered = true;
        myListView.model.setProperty(i, "dataValue", newValue);
        root.valueEntered = false;
        correctionsMade++
    }
    return correctionsMade
}

function validateEntries() {
    var numOutOfRange = 0;
    for (var x = 0; x < myListView.model.count; x++) {
        numOutOfRange += validateParam(x)
    }
    // zero out a parameter if it is excluded by mutual exclusive goal
    if(!root.timeGoal) {
        if(timeItem)
            timeItem.dataValue = 0
    }
    if(!root.distGoal) {
        if(distItem)
            distItem.dataValue = 0
    }
    if(calWarning.visible)
        numOutOfRange++
    return numOutOfRange
}

// Code previously inside ListView delegate

function getItemLabel(item) {
    switch (item.fieldType) {
    case WorkoutProgram.MAX_SPEED_TYPE:
        if (workoutProgram.programIndex === WorkoutProgram.TREAD_CALORIE_PROG) {
            return QT_TRANSLATE_NOOP("WorkoutSetup", "SPEED")
        } else {
            return QT_TRANSLATE_NOOP("WorkoutSetup", "MAX SPEED")
        }
    case WorkoutProgram.MAX_INCLINE_TYPE:
        if (workoutProgram.programIndex === WorkoutProgram.TREAD_CALORIE_PROG) {
            return QT_TRANSLATE_NOOP("WorkoutSetup", "INCLINE")
        } else {
            return QT_TRANSLATE_NOOP("WorkoutSetup", "MAX INCLINE")
        }
    case WorkoutProgram.LEVEL_TYPE:
        if (workoutProgram.programIndex === WorkoutProgram.TREAD_LEG_SHAPER_PROG) {
            return QT_TRANSLATE_NOOP("WorkoutSetup", "SPEED")
        } else {
            return QT_TRANSLATE_NOOP("WorkoutSetup", "LEVEL")
        }
    case WorkoutProgram.SPEED_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "SPEED")
    case WorkoutProgram.RUN_SPEED_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "RUN SPEED")
    case WorkoutProgram.WORK_SPEED_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "WORK SPEED")
    case WorkoutProgram.WALK_SPEED_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "WALK SPEED")
    case WorkoutProgram.REST_SPEED_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "REST SPEED")
    case WorkoutProgram.DISTANCE_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "DISTANCE")
    case WorkoutProgram.DISTANCE_QUICK_TYPE:
    case WorkoutProgram.FIXED_DISTANCE_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "DISTANCE")
    case WorkoutProgram.FLOOR_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "FLOORS")
    case WorkoutProgram.SEGMENT_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "SEGMENTS")
    case WorkoutProgram.TIME_TYPE:
    case WorkoutProgram.TIMEREADONLY_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "WORKOUT TIME")
    case WorkoutProgram.WORKTIME_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "WORK TIME")
    case WorkoutProgram.RESTTIME_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "REST TIME")
    case WorkoutProgram.PACE_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "PACE")
    case WorkoutProgram.WORKLOAD_TYPE:
       if(machineinfo.productTypeString == "Bike" && !workoutScreen.bikeWattsModeRequired)
            return QT_TRANSLATE_NOOP("WorkoutSetup", "GEAR")
        else
            return QT_TRANSLATE_NOOP("WorkoutSetup", "WORKLOAD")
    case WorkoutProgram.AGE_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "AGE")
    case WorkoutProgram.WEIGHT_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "WEIGHT")
    case WorkoutProgram.HEIGHT_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "HEIGHT")
    case WorkoutProgram.GENDER_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "GENDER")
    case WorkoutProgram.INCLINE_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "INCLINE")
    case WorkoutProgram.CALORIES_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "CALORIE GOAL")
    case WorkoutProgram.CALORIE_POTENTIAL_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "CALCULATED CALORIES")

    case WorkoutProgram.WORK_HEARTRATE_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "WORK HEART RATE")
    case WorkoutProgram.REST_HEARTRATE_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "REST HEART RATE")
    case WorkoutProgram.TARGET_HEARTRATE_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "TARGET HEART RATE")
    case WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "TARGET HEART RATE")
    case WorkoutProgram.MIN_STRIDE_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "REST STRIDE")
    case WorkoutProgram.MAX_STRIDE_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "WORK STRIDE")
    case WorkoutProgram.ELEVATION_TYPE:
        return QT_TRANSLATE_NOOP("WorkoutSetup", "CLIMB DISTANCE")
    }
}

// Some items have additional text that cannot be translated
function getItemAdditionalLabel(item) {
    switch (item.fieldType) {
    case WorkoutProgram.PACE_TYPE:
    case WorkoutProgram.WORKLOAD_TYPE:
    case WorkoutProgram.MIN_STRIDE_TYPE:
    case WorkoutProgram.MAX_STRIDE_TYPE:
        return " (" + item.minValue + " - " + item.maxValue + ")"
    default:
        return ""
    }

}

// Code previously inside of ListView element

function getValueString(item)
{
    if (item.precision > 0) {
        if (isSpeedType(item.fieldType)) {
            var valConverted = options.metricUnits ? Globals.mileToKm(item.dataValue) : parseFloat(item.dataValue)
            return valConverted.toFixed(item.precision)
        } else {
            var str = parseFloat(item.dataValue)
            if(!root.distGoal && (item.fieldType == WorkoutProgram.DISTANCE_TYPE || item.fieldType == WorkoutProgram.DISTANCE_QUICK_TYPE)) {
                return "--";
            }

            // special case: display "5K" rather than 5.0K for distance buttons
            if (item.fieldType === WorkoutProgram.DISTANCE_QUICK_TYPE && str - Math.floor(str) === 0.0) {
                return Math.floor(str)
            }

            return str.toFixed(item.precision)
        }
    } else {
        if (item.fieldType == WorkoutProgram.TIME_TYPE) { // Time
            mainProgItem.workTime = item.dataValue;
            mainProgItem.segTime = ((item.dataValue * 60) / mainProgItem.numSegs);
            if(!root.timeGoal) {
                return "--";
            }
            return item.dataValue;
        } else if (isStrideType(item.fieldType)) {
            var val = options.metricUnits ? Globals.inchToCm(item.dataValue) : parseFloat(item.dataValue)
            return Math.round(val)
        } else if (item.fieldType == WorkoutProgram.TIMEREADONLY_TYPE) {
            //                    if(!root.timeGoal) {
            //                        return "--";
            //                    }
            return item.dataValue;
        } else if (item.fieldType == WorkoutProgram.ELEVATION_TYPE) {
            var result = item.dataValue
            // Display as delta of start and end elevation
            result = result.y - result.x
            if (options.metricUnits) {
                result = Globals.feetToMeters(result).toFixed(0)
            }
            return Number(result).toLocaleString() // Format with commas
        } else if (item.fieldType == WorkoutProgram.PACE_TYPE) { // Pace
            mainProgItem.paceLevelForCustom = item.dataValue;
            return item.dataValue;
        } else if (item.fieldType == WorkoutProgram.WORKLOAD_TYPE) { // Workload
            mainProgItem.workloadLevelForCustom = item.dataValue;
            return item.dataValue;
        } else if (item.fieldType == WorkoutProgram.AGE_TYPE) { // Age
            mainProgItem.ageForProgSummary = item.dataValue;
            return item.dataValue;
        } else if (item.fieldType == WorkoutProgram.WEIGHT_TYPE) { // Weight
            mainProgItem.weightForProgSummary = item.dataValue;
            return item.dataValue;
        } else if (item.fieldType == WorkoutProgram.HEIGHT_TYPE) { // Weight
            return item.dataValue;
        } else if (item.fieldType == WorkoutProgram.GENDER_TYPE) { // Weight
            return item.dataValue ? qsTr("F", "Female Gender Intial") + application.emptyString : qsTr("M", "Male Gender Intial") + application.emptyString
        } else if (item.fieldType == WorkoutProgram.INCLINE_TYPE || item.fieldType == WorkoutProgram.MAX_INCLINE_TYPE) { // incline
            return (workoutProgram.inclineTable[item.dataValue]/10).toFixed(1)
        } else if (isSpeedType(item.fieldType)) {
            if(main.isStepmill){
                return item.dataValue;
            }
            return options.metricUnits ? Globals.mileToKm(item.dataValue) : item.dataValue
        } else if (item.fieldType === WorkoutProgram.WORKTIME_TYPE || item.fieldType === WorkoutProgram.RESTTIME_TYPE) { // Time
            return item.dataValue;
        } else {
            return item.dataValue ? item.dataValue : ""
        }
    }
}

function calculateHRPercentage () {
    var userAge = 0;
    var tempHR = 0;
    var tempCalcHRPercent = 0;

    for (var i = 0; i < myListView.count; i++)
    {
        if (myListView.model.get(i).fieldType == WorkoutProgram.AGE_TYPE) {
            userAge = myListView.model.get(i).dataValue;
        }
        else if (myListView.model.get(i).fieldType == WorkoutProgram.WORK_HEARTRATE_TYPE ||
                 myListView.model.get(i).fieldType == WorkoutProgram.REST_HEARTRATE_TYPE ||
                 myListView.model.get(i).fieldType == WorkoutProgram.TARGET_HEARTRATE_TYPE ||
                 myListView.model.get(i).fieldType == WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE) {
            // HR
            tempHR = myListView.model.get(i).dataValue;
        }
        if (userAge > 0 && tempHR > 0) {
            if (tempHR > (220 - userAge)) {
                tempHR = (220 - userAge);
                myListView.model.setProperty(i, "dataValue", Math.round(tempHR));
            }
            tempCalcHRPercent = ((tempHR / (220 - userAge)) * 100);
            myListView.model.setProperty(i, "heartRatePercentage", Math.round(tempCalcHRPercent));
            tempHR = 0;
        }
    }

}

function calculateHRFromAge () {
    var userAge = 0;
    var tempHR = 0;
    var tempHRPercent = 0;

    for (var i = 0; i < myListView.count; i++)
    {
        if (myListView.model.get(i).fieldType == WorkoutProgram.AGE_TYPE) {
            userAge = myListView.model.get(i).dataValue;
        }
        else if (myListView.model.get(i).fieldType == WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE) {
            tempHRPercent = myListView.model.get(i).heartRatePercentage;
        }
        if (userAge > 0 && tempHRPercent > 0) {
            tempHR = ((220 - userAge) * (tempHRPercent / 100.0));
            myListView.model.setProperty(i, "dataValue", Math.round(tempHR));
            tempHRPercent = 0;
        }
    }
}

function getMaxDigit(maxValue)
{
    var str = maxValue.toString()
    return str.length
}

// "micro functions" - callbacks to onChanged and other events that have shared code between Keyed and non-Keyed
// versions, but are not really conceptually meaningful.
function itemValueDetailsTextChanged(sliderObject, sliderObject2, sliderObject3, genderSlider, model) {
    if (root.valueEntered) {
        sliderObject.value = model.dataValue;
        sliderObject2.value = model.dataValue;
        sliderObject3.value = model.dataValue;
        genderSlider.value = model.dataValue;
        print("slider change:" + model.dataValue)
        root.valueEntered = false;
    }
}

function sliderObjectValueChanged(model, value, valueProxyChange) {
    if (!root.valueEntered && !valueProxyChange) {
        // If time/distance has been explicitly zeroed out (e.g. from a saved manual workout being reloaded), prevent the slider
        // from resetting that to the min value (typically 5 minutes) and instead keep the zero value.
        if (value === model.minValue && ((model.fieldType === WorkoutProgram.TIME_TYPE && model.dataValue === 0) || (model.fieldType === WorkoutProgram.DISTANCE_TYPE && model.dataValue === 0))) {
        } else {
            model.dataValue = value;
            mainProgItem.dataItemChanged()
        }
    }

    if (model.fieldType === WorkoutProgram.TIME_TYPE) {
        // segments must be 1:00 long minimum, so adjust segment max based on workout time
        calculateMaxSegmentsFromTime()
    }

//    if (model.fieldType === WorkoutProgram.SPEED_TYPE) {
//        console.debug("speed type found: "+value)
//        workoutManager.setSpeedLevel(value)
//    }

    if (mainProgItem.targetHRType === mainProgItem.targetHRTypeEnum.aerobic) {
        calculateHRFromAge();
    } else if (mainProgItem.targetHRType === mainProgItem.targetHRTypeEnum.target) {
        calculateHRPercentage();
    }
}

function genderSliderValueChanged(model, value) {
    if(model.fieldType != WorkoutProgram.GENDER_TYPE)
        return
    if (!root.valueEntered) {
        model.dataValue = value;
        mainProgItem.dataItemChanged()
    }
}
/*
function sliderObject2ValueChanged(model, value, index) {
    if (model.fieldType != WorkoutProgram.WORK_HEARTRATE_TYPE &&
        model.fieldType != WorkoutProgram.REST_HEARTRATE_TYPE &&
        model.fieldType != WorkoutProgram.TARGET_HEARTRATE_TYPE)
        return

    if (!root.valueEntered) {
        myListView.model.setProperty(index, "dataValue", value);

        dataItemChanged()
    }

    if (mainProgItem.targetHRType == mainProgItem.targetHRTypeEnum.aerobic) {
        calculateHRFromAge();
    }
    else if (mainProgItem.targetHRType == mainProgItem.targetHRTypeEnum.target) {
        calculateHRPercentage();
    }
}
*/
function sliderObject3ValueChanged(model, value) {
    if (model.fieldType === WorkoutProgram.SEGMENT_TYPE) {
        model.dataValue = value;
        mainProgItem.numSegs = value;
        mainProgItem.dataItemChanged()
    }
}

// functions from levelDetails

function levelDetailsGetLabel() {
    switch (workoutProgram.programIndex) {
    case WorkoutProgram.TREAD_CARDIO_CHALLENGE_PROG:
    case WorkoutProgram.TREAD_GLUTE_BUSTER_PROG:
    case WorkoutProgram.TREAD_HILL_INTERVALS_PROG:
    case WorkoutProgram.TREAD_ROLLING_HILLS_PROG:
    case WorkoutProgram.TREAD_SINGLE_HILL_PROG:
    case WorkoutProgram.TREAD_WEIGHT_LOSS_HILLS_PROG:
    case WorkoutProgram.TREAD_RANDOM_HILLS_PROG:
    case WorkoutProgram.ALPINE_RANDOM_HILLS_PROG:
        return qsTr("MAX INCLINE") + application.emptyString
    case WorkoutProgram.TREAD_LEG_SHAPER_PROG:
        return qsTr("MAX SPEED") + application.emptyString
    default:
        return ""
    }
}

function levelDetailsGetProfile() {
    switch (workoutProgram.programIndex) {
    case WorkoutProgram.TREAD_CARDIO_CHALLENGE_PROG:
    case WorkoutProgram.TREAD_GLUTE_BUSTER_PROG:
    case WorkoutProgram.TREAD_HILL_INTERVALS_PROG:
    case WorkoutProgram.TREAD_ROLLING_HILLS_PROG:
    case WorkoutProgram.TREAD_SINGLE_HILL_PROG:
    case WorkoutProgram.TREAD_WEIGHT_LOSS_HILLS_PROG:
    case WorkoutProgram.TREAD_RANDOM_HILLS_PROG:
    case WorkoutProgram.ALPINE_RANDOM_HILLS_PROG:
        return workoutProgram.profile1 // incline
    case WorkoutProgram.TREAD_LEG_SHAPER_PROG:
        return workoutProgram.profile2 // speed
    }
}

function levelDetailsGetSubValue(level) {
    var profile = levelDetailsGetProfile()
    if (!profile)
        return ""

    var result = profile.findMaxWithLevel("segmentMagnitude", level)
    result = parseInt(result)/10.0
    if (options.metricUnits && profile.segmentType === WorkoutProfile.SPEED_SEG_TYPE)
        result = Globals.mileToKm(result)

    console.log("level details value: ", result.toFixed(1))
    return result.toFixed(1)
}

function levelDetailsGetUnits() {
    switch (workoutProgram.programIndex) {
    case WorkoutProgram.TREAD_CARDIO_CHALLENGE_PROG:
    case WorkoutProgram.TREAD_GLUTE_BUSTER_PROG:
    case WorkoutProgram.TREAD_HILL_INTERVALS_PROG:
    case WorkoutProgram.TREAD_ROLLING_HILLS_PROG:
    case WorkoutProgram.TREAD_SINGLE_HILL_PROG:
    case WorkoutProgram.TREAD_WEIGHT_LOSS_HILLS_PROG:
    case WorkoutProgram.TREAD_RANDOM_HILLS_PROG:
    case WorkoutProgram.ALPINE_RANDOM_HILLS_PROG:
        return "%"
    case WorkoutProgram.TREAD_LEG_SHAPER_PROG:
        return (options.metricUnits ? qsTr("KPH") : qsTr("MPH")) + application.emptyString
    default:
        return ""
    }
}

function isHeartRateType(fieldType) {
    switch (fieldType) {
        case WorkoutProgram.WORK_HEARTRATE_TYPE:
        case WorkoutProgram.REST_HEARTRATE_TYPE:
        case WorkoutProgram.TARGET_HEARTRATE_TYPE:
        case WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE:
            return true
        default:
            return false
    }
}

function isReadOnlyType(fieldType) {
    switch (fieldType) {
        case WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE:
        case WorkoutProgram.FIXED_DISTANCE_TYPE:
        case WorkoutProgram.TIMEREADONLY_TYPE:
        case WorkoutProgram.CALORIE_POTENTIAL_TYPE:
            return true
        default:
            return false
    }
}
