import QtQuick 2.12
import Components 1.0
import WorkoutManager 1.0

Item {
    id: root
    clip:false

    property int elapsedTime: aWorkoutRunData.workoutTime + aWorkoutRunData.coolDownTime
    property int numSegments: 10

    property bool isMenuDisplayed: false
    signal action()

    GraphView {
        id: profile1View
        visible: !options.enableProtoGraphs
        anchors {
            left: parent.left
            right: parent.right
            top: parent.top
            topMargin: 0
            bottom: parent.bottom
            bottomMargin: 0
        }
        model1: workoutProgram.profile1
        model2: workoutProgram.profile2
        columnWidth: root.width/root.numSegments/2.5
        segmentFill: (100 * (root.elapsedTime / model1.segmentDuration)) % 100
        activeSegment: workoutManager.currentSegment

        isMenuDisplayed: root.isMenuDisplayed
        onAction: root.action()
    }

    LineGraphView {
        id: newProfileView
        visible: options.enableProtoGraphs & root.visible
        anchors {
            left: parent.left
            right: parent.right
            top: parent.top
            topMargin: 0
            bottom: parent.bottom
            bottomMargin: 0
        }
        model1: workoutProgram.profile1
        model2: workoutProgram.profile2

        isMenuDisplayed: root.isMenuDisplayed
        onAction: root.action()
    }
}

