import QtQuick 2.12
import ".."
import Components 1.0

Item{
    id: root

    property bool isMenuDisplayed: false
    property bool isMenuMoving: false
    signal action()

    anchors.verticalCenter: parent.verticalCenter
    anchors.horizontalCenter: parent.horizontalCenter

    Connections {
        target: currentViewName === "PROFILE_VIEW" && visible && opacity > 0 ? keymapper : null

        onEnter2Pressed: {
            main.debugKeys("enter2Pressed", "ProfileViewContainer")
            profileContainer.nextTab();
        }
    }

    function shown(){
        // No TV or browser audio when viewing the profile only Bluetooth.
        audioManager.btRequest()
        visible = true
    }

    function hidden() {
        visible = false
    }

    ProfileContainer {
        id: profileContainer
        visible: root.visible
        width: parent.width
        height: parent.height
        anchors.bottom: parent.bottom
        anchors.horizontalCenter: parent.horizontalCenter

        isMenuDisplayed: root.isMenuDisplayed
        onAction: root.action()
    }

}
